# ===== マンカラ（人対人）============================================================
# ------>  上：右回り
# ------>  下：左回り

import tkinter
import time 

st1=0      # スタート時の皿の番号（1,--,6)
st2=0
x0=0       # スタート時の石の個数 x0=[st1] or [st2]
index=0
tmr=0
key=""
jun=1       # 順番 1 or 2
ind=0       # どちらかが勝利で１
a=[0,0,0,0,0,0,0,0]  # 1,--,7    a[1] [2] [3] [4] [5] [6]
                 #           b[0]                        a[7]  
b=[0,0,0,0,0,0,0]    # 0,--,6    b[1] [2] [3] [4] [5] [6]

# ------------------------------------------------------------------------------------

def key_down(e):        # Key Down
    global key
    key=e.keysym
def key_up(e):          # Key Up
    global key
    key=""
def draw_kazu():      # 現在のkazuリストのデータで全て表示
    cvs.delete("KAZU")
    for x in range(1,7):    # a[*]: * * * * * * (1,--,6)
        cvs.create_image(x*150+70,220,image=img_kazu[a[x]],tag="KAZU")
    draw_text(str(a[7]),1110,315,25,"blue","KAZU")     # 右箱 d
    for x in range(1,7):    # b[*]: * * * *`* * (5,--,0)
        cvs.create_image(x*150+70,420,image=img_kazu[b[x]],tag="KAZU")
    draw_text(str(b[0]),80,315,25,"blue","KAZU")       # 左箱 c

def draw_text(txt,x,y,siz,col,tg):      # テキスト表示（影付き）
    fnt=("Times New Roman",siz,"bold")
#    cvs.create_text(x+3,y+3,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)
#    draw_text("↑",300,230,30,"red","YA")    

def teban_1():      # ------------------ 手番１ -----------------------------
    global st1,x0
    cvs.delete("YA")
    if key=="Left" and st1>=2:   # strt:スタート時の皿の番号 (1,--,6)
        st1-=1
    if key=="Right" and st1<=5:
        st1+=1
    if key=="Up":
        cvs.delete("HIT")
        cvs.delete("YA")
        x0=a[st1]    # st1: 1,--,6    x0:皿に入っていた石の個数
        if x0>0:
            a[st1]=0      # スタートした皿を空にする
            koma_idou1()        # 駒移動の関数
        else:
            jun=1   # 個数 0 の皿を↓するとやり直し
    draw_text("↑",70+150*st1,268,40,"white","YA")     

def koma_idou1():   # 手番１の駒の移動 -----
    global st1,x0,jun,ind,tmr
    if x0+st1>=15:
        for x in range(st1+1,8):    # st1+1,--,7
            a[x]+=1
        for x in range(6,-1,-1):    # 6,--,0
            b[x]+=1
        for x in range(0,x0+st1-13):     # 0,--,x0+st1-14
            a[x]+=1
    else:    
        if x0+st1>=8:
            for x in range(st1+1,8):    # st1+1,--,7
                a[x]+=1
            for x in range(6,13-x0-st1,-1):    # 6,--,14-x0-st1
                b[x]+=1
        else:   # x0+st1<=7
            for x in range(st1+1,st1+x0+1):     # st1+1,--,st1+x0
                a[x]+=1
    if a[1]+a[2]+a[3]+a[4]+a[5]+a[6]==0:
        draw_text("勝利！",300,150,40,"red","KATI")         # 表示「勝利！」
        ind=1
        tmr=0
    if a[1]>14 or a[2]>14 or a[3]>14 or a[4]>14 or a[5]>14 or a[6]>14:
        draw_text("負け",300,150,40,"white","KATI")          # 「負け」
        ind=1
        tmr=0
    if x0+st1==7 or x0+st1==14:
        draw_text("Hit!",600,170,25,"pink","HIT")         # 表示「ヒット！」
        jun=1
    else:
        jun=2
    cvs.delete("YA")

def teban_2():      # ---------------------- 手番２ -------------------------      
    global st2,x0
    cvs.delete("YA")
    if key=="Left" and st2>=2:     # strt:スタート時の皿の番号 (0,--,5)
        st2=st2-1
    if key=="Right" and st2<=5:
        st2=st2+1
    if key=="Down":
        cvs.delete("HIT")
        cvs.delete("YA")        
        x0=b[st2]    # st2:1,--,6    x0:皿に入っていた石の個数
        if x0>0:
            b[st2]=0      # スタートした皿を空にする
            koma_idou2()
        else:
            jun=2   # 個数 0 の皿を↓するとやり直し
        cvs.delete("YA")    
    draw_text("↓",70+150*st2,370,40,"white","YA")

def koma_idou2():   # 手番２の駒の移動 -----
    global st2,x0,jun,ind,tmr
    jun=1
    if x0+st2>=15:
        for x in range(st2+1,7):
            b[x]+=1
        for x in range(7,-1,-1):
            a[x]+=1
        for x in range(0,x0+st2-13):
            b[x]+=1           
    else:    
        if x0+st2>=7:
            for x in range(st2+1,7):
                b[x]+=1
            for x in range(7,13-x0-st2,-1):
                a[x]+=1
        else:   # x0+st2<=6
            for x in range(st2+1,st2+x0+1):
                b[x]+=1

    if b[1]+b[2]+b[3]+b[4]+b[5]+b[6]==0:
        draw_text("勝利！",300,500,40,"red","KATI")         # 表示「勝利！」
        ind=1
        tmr=0
    if b[1]>14 or b[2]>14 or b[3]>14 or b[4]>14 or b[5]>14 or b[6]>14:
        draw_text("負け",300,500,40,"white","KATI")          # 「負け」
        ind=1
        tmr=0
    if x0+st2==7 or x0+st2==14:
        draw_text("Hit!",600,480,25,"pink","HIT")         # 表示「ヒット！」        
        jun=2
    else:
        jun=1
    cvs.delete("YA")    


def main_proc(): # ====================================================================
    global index,tmr,jun,x0,ind,st1,st2,a,b,c,d
    if index==0:
        cvs.create_rectangle(140,200,1050,250,fill="black")     # 黒い帯＿上
        cvs.create_rectangle(140,400,1050,450,fill="black")
        cvs.create_image(80,320,image=img_hako2,tag="HAKO")    # 黒い箱＿左
        cvs.create_image(1110,320,image=img_hako2,tag="HAKO")
        draw_kazu()
        if tmr>=15:
            tmr=0
            cvs.delete("HIT")
            cvs.delete("KATI")
            cvs.delete("YA")           
            jun=1
            ind=0
            st1=3
            st2=3     
            a=[0,4,4,4,4,4,4,0]     # a[7]:右ポケット    a[0]:不使用
            b=[0,4,4,4,4,4,4]       # b[0]:左ポケット
            c=0
            d=0  
            draw_kazu()
            index=1
    elif index==1:      # --- 手番１ --------------------------
        teban_1()
        draw_kazu()
        if ind==1:      # １の勝利で、ind=1
            index=0
        else:           # まだ勝負がつかなければ
            if jun==2:  # 関数内で、手番の交替済み（jun=1 => jun=2）になっている
                index=2
    elif index==2:      # --- 手番２ --------------------------
        teban_2()
        draw_kazu()
        if ind==1:      # ２の勝利で、ind=1
            index=0
        else:
            if jun==1:
                index=1
    tmr=tmr+1
    root.after(230,main_proc)       # root.after 300
# =====================================================================================
    
root=tkinter.Tk()                       # root=tkinter.Tk()
root.title("マンカラ")
root.bind("<KeyPress>",key_down)        # key_down
root.bind("<KeyRelease>",key_up)        # key_up
cvs=tkinter.Canvas(width=1200,height=650,bg="green")    # Canvas: 1200x650 => cvs
draw_text("マンカラ",600,50,45,"yellow","TITLE")         # タイトル表示「マンカラ」
draw_text("≫≫≫",900,170,30,"yellow","TITLE")
draw_text("≫≫≫",900,480,30,"yellow","TITLE")
img_hako2=tkinter.PhotoImage(file="hako_2.png")
cvs.pack()                
        
img_kazu=[
    tkinter.PhotoImage(file="man_0.png"),  
    tkinter.PhotoImage(file="man_1.png"),  
    tkinter.PhotoImage(file="man_2.png"),  
    tkinter.PhotoImage(file="man_3.png"),
    tkinter.PhotoImage(file="man_4.png"),
    tkinter.PhotoImage(file="man_5.png"),
    tkinter.PhotoImage(file="man_6.png"),
    tkinter.PhotoImage(file="man_7.png"),
    tkinter.PhotoImage(file="man_8.png"),
    tkinter.PhotoImage(file="man_9.png"),
    tkinter.PhotoImage(file="man_10.png"),
    tkinter.PhotoImage(file="man_11.png"),
    tkinter.PhotoImage(file="man_12.png"),
    tkinter.PhotoImage(file="man_13.png"),
    tkinter.PhotoImage(file="man_14.png"),
    tkinter.PhotoImage(file="man_15.png")    
]

main_proc()
root.mainloop()

